package com.swtjface.flowchart.commands;

import org.eclipse.gef.commands.Command;
import com.swtjface.flowchart.model.*;

public class PathCommand
  extends Command
{
  protected Activity oldSource, source;
  protected Activity oldTarget, target;
  protected String oldSourceName, sourceName;
  protected String oldTargetName, targetName;
  protected Path path;

  public PathCommand()
  {}

  public boolean canExecute()
  {
    return true;
  }
  
  public void execute()
  {
    if (source != null)
    {
      path.detachSource();
      path.setSource(source);
      path.setSourceName(sourceName);
      path.attachSource();
    }
    if (target != null)
    {
      path.detachTarget();
      path.setTarget(target);
      path.setTargetName(targetName);
      path.attachTarget();
    }
  }

  public void redo()
  {
    execute();
  }

  public void undo()
  {
    source = path.getSource();
    target = path.getTarget();
    sourceName = path.getSourceName();
    targetName = path.getTargetName();
    path.detachSource();
    path.detachTarget();
    path.setSource(oldSource);
    path.setTarget(oldTarget);
    path.setSourceName(oldSourceName);
    path.setTargetName(oldTargetName);
    path.attachSource();
    path.attachTarget();
  }

  public void setSource(Activity newSource)
  {
    source = newSource;
  }

  public void setSourceName(String newSourceName)
  { 
    sourceName = newSourceName;
  }

  public void setTarget(Activity newTarget)
  {
    target = newTarget;
  }

  public void setTargetName(String newTargetName)
  {
    targetName = newTargetName;
  }

  public void setPath(Path p)
  {
    path = p;
    oldSource = p.getSource();
    oldTarget = p.getTarget();
    oldSourceName = p.getSourceName();
    oldTargetName = p.getTargetName();
  }
}