package com.swtjface.flowchart.editpart;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.List;
import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.editparts.*;
import com.swtjface.flowchart.figures.FigureFactory;
import com.swtjface.flowchart.model.Chart;
import com.swtjface.flowchart.policies.*;

public class ChartPart extends AbstractGraphicalEditPart
  implements PropertyChangeListener
{
  public void propertyChange(PropertyChangeEvent evt)
  {
    String prop = evt.getPropertyName();
    if (Chart.CHILD.equals(prop))
      refreshChildren();
  }

  protected IFigure createFigure()
  {
    return FigureFactory.createChartFigure();
  }

  protected void createEditPolicies()
  {
    installEditPolicy(EditPolicy.LAYOUT_ROLE, new LayoutPolicy());
  }

  public void activate()
  {
    if (isActive())
      return;
    super.activate();
    getChart().addPropertyChangeListener(this);
  }

  public void deactivate()
  {
    if (!isActive())
      return;
    super.deactivate();
    getChart().removePropertyChangeListener(this);
  }

  protected Chart getChart()
  {
    return (Chart)getModel();
  }

  protected List getModelChildren()
  {
    return getChart().getChildren();
  }
}