package com.swtjface.flowchart.model;

import java.io.*;
import java.beans.*;

abstract public class AbstractChartElement
  implements Cloneable, Serializable
{
  public static final String
  SIZE = "size", LOC = "location", NAME = "name",
  CHILD = "children", TARGETS = "targets", SOURCES = "sources";
  
  transient protected PropertyChangeSupport listeners = new
    PropertyChangeSupport(this);
  
  public void addPropertyChangeListener(PropertyChangeListener pcl)
  {
    listeners.addPropertyChangeListener(pcl);
  }

  public void removePropertyChangeListener
    (PropertyChangeListener pcl)
  {
  	listeners.removePropertyChangeListener(pcl);
  }

  protected void firePropertyChange(String propName,
  	Object old, Object newValue)
  {
  	listeners.firePropertyChange(propName, old, newValue);
  }
  
  private void readObject(ObjectInputStream in) throws IOException,
  	ClassNotFoundException
  {
  	in.defaultReadObject();
  	listeners = new PropertyChangeSupport(this);
  }
}