package com.swtjface.flowchart.model;

import org.eclipse.gef.requests.CreationFactory;
import com.swtjface.flowchart.palette.*;

public class ModelFactory
  implements CreationFactory
{
  private String template;
  public ModelFactory(Object str)
  {
    template = (String) str;
  }

  public Object getNewObject() 
  {
    if (FlowchartPalette.TERMINATOR_TEMPLATE.equals(template))
      return new Terminator();
    if (FlowchartPalette.DECISION_TEMPLATE.equals(template))
      return new Decision();
    if (FlowchartPalette.PROCESS_TEMPLATE.equals(template))
      return new Process();
    return null;
  }

  public Object getObjectType()
  {
    return template;
  }

  public static Chart getChart() 
  {
    return new Chart();
  }

  public Path getPath()
  {
    return new Path();
  }
}