package com.swtjface.flowchart.model;

public class Path
  extends AbstractChartElement
{
  protected Activity source, target;
  protected String sourceName, targetName;
  public void attachSource()
  {
    if (getSource() == null ||
      getSource().getSourceConnections().contains(this))
        return;
    getSource().addSourceConnection(this);
  }
  
  public void detachSource()
  {
    if (getSource() == null)
      return;
    getSource().removeSourceConnection(this);
  }
  
  public void attachTarget()
  {
    if (getTarget() == null ||
      getTarget().getTargetConnections().contains(this))
    return;
    getTarget().addTargetConnection(this);
  }
  
  public void detachTarget()
  {
    if (getTarget() == null)
      return;
    getTarget().removeTargetConnection(this);
  }
  
  public Activity getSource()
  {
    return source;
  }
  
  public void setSource(Activity e)
  {
    source = e;
  }

  public Activity getTarget()
  {
    return target;
  }
  
  public void setTarget(Activity e)
  {
    target = e;
  }
  
  public String getSourceName()
  {
    return sourceName;
  }
  
  public void setSourceName(String s)
  {
    sourceName = s;
  }
  
  public String getTargetName()
  {
    return targetName;
  }

  public void setTargetName(String s)
  {
    targetName = s;
  }
}