package com.swtjface.flowchart.policies;

import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.*;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.*;
import org.eclipse.gef.requests.*;
import com.swtjface.flowchart.model.*;
import com.swtjface.flowchart.commands.*;

public class LayoutPolicy extends XYLayoutEditPolicy
{
  protected Command createAddCommand(EditPart childEditPart, Object constraint)
  {
    Activity part = (Activity) childEditPart.getModel();
    Rectangle rect = (Rectangle)constraint;
    CreateCommand create = new CreateCommand();
    create.setParent((Chart)(getHost().getModel()));
    create.setChild(part);
    create.setConstraint(rect);
    return create;
  }

  protected Command createChangeConstraintCommand(EditPart child, Object constraint)
  {
    SetConstraintCommand locationCommand = new SetConstraintCommand();
    locationCommand.setPart((Activity)child.getModel());
    locationCommand.setLocation((Rectangle)constraint);
    return locationCommand;
  }  

  protected Command createChangeConstraintCommand
    (ChangeBoundsRequest request, EditPart child, Object constraint)
  {
    SetConstraintCommand cmd = (SetConstraintCommand)
	  createChangeConstraintCommand(child, constraint);
    return cmd;
  }

  protected Command getCreateCommand(CreateRequest request)
  {
    CreateCommand create = new CreateCommand();
    create.setParent((Chart)(getHost().getModel()));
    create.setChild((Activity)(request.getNewObject()));
    Rectangle constraint = (Rectangle)getConstraintFor(request);
    create.setConstraint(constraint);
    return create;
  }

  protected Command getDeleteDependantCommand(Request request)
  {return null;}
  
  protected EditPolicy createChildEditPolicy(EditPart child)
  {
    ResizableEditPolicy policy = new ResizableEditPolicy();
    policy.setResizeDirections(PositionConstants.EAST |
    PositionConstants.WEST | PositionConstants.NORTH |
    PositionConstants.SOUTH);
    return policy;
  }
}